.PHONY: help
help:
	@echo "------------------------------------------------------------HELP------------------------------------------------------------------"
	@echo "make fmt                                            - format code"
	@echo "make lint                                           - lint code"
	@echo "make deps                                           - download app dependencies"
	@echo "make test                                           - run unit tests"
	@echo "make cover                                          - run unit tests and open HTML coverage report"
	@echo "---------------------------------------------------------------------------------------------------------------------------------"


################################################################################
# Format code
################################################################################
.PHONY: fmt
fmt:
	find . -name '*.go' | grep -v vendor | xargs gofmt -s -w

################################################################################
# Lint code
################################################################################
.PHONY: lint
lint:
	bash ./scripts/lint.sh

################################################################################
# Download app dependencies
################################################################################
.PHONY: deps
deps:
	go mod download
	go mod verify

################################################################################
# Run unit tests
################################################################################
.PHONY: test
test:
	go test -coverprofile=assets/coverage.out -timeout 10s -count 1 -race ./...

################################################################################
# Run unit tests and view coverage in HTML
################################################################################
.PHONY: cover
cover: test
	go tool cover -html=assets/coverage.out